Skip to content

Create Bot Infrastructure.

POST
/api/shape/bot/namespaces/{metadata.namespace}/bot_infrastructures
curl --request POST \
--url https://example-corp.console.ves.volterra.io/api/v1/api/production/us-east-1/namespaces/default/api/shape/bot/namespaces/example/bot_infrastructures \
--header 'Authorization: <Authorization>' \
--header 'Content-Type: application/json' \
--data '{ "metadata": { "annotations": {}, "description": "example", "disable": true, "labels": {}, "name": "example", "namespace": "example" }, "spec": { "create_cloud_hosted": { "ip_addresses": [ "example" ], "production": { "region_1": "example", "region_2": "example" }, "testing": { "region_1": "example" } }, "traffic_type": "WEB" } }'

Create Bot Infrastructure.

Examples of this operation.

metadata.namespace
required
string

Namespace This defines the workspace within which each the configuration object is to be created. Must be a DNS_LABEL format. For a namespace object itself, namespace value will be ""

Media typeapplication/json
CreateRequest is used to create an instance of bot_infrastructure

This is the input message of the ‘Create’ RPC.

object
metadata
object
annotations
annotations

Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects.

object
description
description

Human readable description for the object.

string
>= 21 characters <= 1200 characters
disable
disable

A value of true will administratively disable the object.

boolean format: boolean
labels
labels

Map of string keys and values that can be used to organize and categorize (scope and select) objects as chosen by the user. Values specified here will be used by selector expression.

object
name
name

This is the name of configuration object. It has to be unique within the namespace. It can only be specified during create API and cannot be changed during replace API. The value of name has to follow DNS-1035 format. Required: YES.

string
>= 6 characters <= 1024 characters
namespace
namespace

This defines the workspace within which each the configuration object is to be created. Must be a DNS_LABEL format. For a namespace object itself, namespace value will be ""

string
>= 6 characters <= 1024 characters
spec
object
create_cloud_hosted
object
ip_addresses
IP Allowlist

Only traffic from these IP addresses is allowed to access this Bot Defense infrastructure.

Array<string>
production
object
region_1
Bot Infrastructure Regions

This is an Active-Active Infrastructure configuration where traffic is routed equally between the two regions.

Required: YES.

string
<= 1024 characters
region_2
Bot Infrastructure Regions

This is an Active-Active Infrastructure configuration where traffic is routed equally between the two regions.

Required: YES.

string
<= 1024 characters
testing
object
region_1
Bot Infrastructure Regions

This is an Active-Passive Infrastructure configuration where traffic is routed to a single region.

Required: YES.

string
<= 1024 characters
traffic_type
string
default: WEB
Allowed values: WEB MOBILE

A successful response.

Media typeapplication/json
object
metadata
object
annotations
annotations

Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects.

object
description
description

Human readable description for the object.

string
>= 21 characters <= 1200 characters
disable
disable

A value of true will administratively disable the object.

boolean format: boolean
labels
labels

Map of string keys and values that can be used to organize and categorize (scope and select) objects as chosen by the user. Values specified here will be used by selector expression.

object
name
name

This is the name of configuration object. It has to be unique within the namespace. It can only be specified during create API and cannot be changed during replace API. The value of name has to follow DNS-1035 format. Required: YES.

string
>= 6 characters <= 1024 characters
namespace
namespace

This defines the workspace within which each the configuration object is to be created. Must be a DNS_LABEL format. For a namespace object itself, namespace value will be ""

string
>= 6 characters <= 1024 characters
spec
object
bot_allowlist_policy_metadata
object
name
Policy Name

Policy Name.

string
>= 6 characters <= 1024 characters
version
Policy Version

Policy Version.

string
>= 1 characters <= 1024 characters
bot_endpoint_policy_metadata
object
name
Policy Name

Policy Name.

string
>= 6 characters <= 1024 characters
type
string
default: WEB
Allowed values: WEB MOBILE
version
Policy Version

Policy Version.

string
>= 1 characters <= 1024 characters
bot_network_policy_metadata
object
name
Policy Name

Policy Name.

string
>= 6 characters <= 1024 characters
version
Policy Version

Policy Version.

string
>= 1 characters <= 1024 characters
cloud_hosted
object
egress
Egress

Egress IP Addresses.

Array<object>
Egress

Egress

object
ip_address
IP Address

Egress IP address Required: YES.

string
<= 1024 characters
region
string
default: AP_NORTHEAST_1
Allowed values: AP_NORTHEAST_1 AP_NORTHEAST_3 AP_SOUTH_1 AP_SOUTH_2 AP_SOUTHEAST_1 AP_SOUTHEAST_2 AP_SOUTHEAST_3 EU_CENTRAL_1 EU_NORTH_1 EU_WEST_1 ME_SOUTH_1 ME_CENTRAL_1 SA_EAST_1 US_EAST_1 US_EAST_2 US_WEST_1 US_WEST_2 AF_SOUTH_1 GCP_ASIA_EAST1 GCP_ASIA_EAST2 GCP_ASIA_NORTHEAST1 GCP_ASIA_NORTHEAST2 GCP_ASIA_NORTHEAST3 GCP_ASIA_SOUTH1 GCP_ASIA_SOUTHEAST1 GCP_ASIA_SOUTHEAST2 GCP_AUSTRALIA_SOUTHEAST1 GCP_EUROPE_WEST1 GCP_EUROPE_WEST2 GCP_EUROPE_WEST3 GCP_NORTHAMERICA_NORTHEAST1 GCP_NORTHAMERICA_NORTHEAST2 GCP_SOUTHAMERICA_EAST1 GCP_SOUTHAMERICA_WEST1 GCP_US_CENTRAL1 GCP_US_EAST1 GCP_US_EAST4 GCP_US_WEST1 GCP_US_WEST2
firmware_version
Firmware Version

The version of firmware for the cluster.

string
<= 1024 characters
host_names
Allowed Host Names

Only traffic from machines with these host names is allowed to access this Bot Defense infrastructure.

Array<string>
infra_host_name
Infra host name

Human-readable name for the resource

string
<= 1024 characters
ingress
Ingress

Ingress Host Names or IP Addresses.

Array<object>
Ingress

Ingress

object
host_name
Host Name

Exclusive with [ip_address]

string
<= 1024 characters
ip_address
IP Address

Exclusive with [host_name] Ingress IP Address.

string
<= 1024 characters
region
string
default: AP_NORTHEAST_1
Allowed values: AP_NORTHEAST_1 AP_NORTHEAST_3 AP_SOUTH_1 AP_SOUTH_2 AP_SOUTHEAST_1 AP_SOUTHEAST_2 AP_SOUTHEAST_3 EU_CENTRAL_1 EU_NORTH_1 EU_WEST_1 ME_SOUTH_1 ME_CENTRAL_1 SA_EAST_1 US_EAST_1 US_EAST_2 US_WEST_1 US_WEST_2 AF_SOUTH_1 GCP_ASIA_EAST1 GCP_ASIA_EAST2 GCP_ASIA_NORTHEAST1 GCP_ASIA_NORTHEAST2 GCP_ASIA_NORTHEAST3 GCP_ASIA_SOUTH1 GCP_ASIA_SOUTHEAST1 GCP_ASIA_SOUTHEAST2 GCP_AUSTRALIA_SOUTHEAST1 GCP_EUROPE_WEST1 GCP_EUROPE_WEST2 GCP_EUROPE_WEST3 GCP_NORTHAMERICA_NORTHEAST1 GCP_NORTHAMERICA_NORTHEAST2 GCP_SOUTHAMERICA_EAST1 GCP_SOUTHAMERICA_WEST1 GCP_US_CENTRAL1 GCP_US_EAST1 GCP_US_EAST4 GCP_US_WEST1 GCP_US_WEST2
ip_addresses
IP Allowlist

Only traffic from these IP addresses is allowed to access this Bot Defense infrastructure.

Array<string>
cluster_state
string
default: ACTIVE
Allowed values: ACTIVE INACTIVE PASSIVE_PROXY EMERGENCY_STOP UNAVAILABLE RECONCILE STARTING_ACTIVE STOPPING_ACTIVE UPDATING_FIRMWARE UPDATING_POLICY WAITING_ACTIVE WAITING_START_TIMEOUT
environment_type
string
default: PRODUCTION
Allowed values: PRODUCTION TESTING
on_prem
object
devices
Devices

The devices assgined to the cluster.

Array<object>
Devices

The device details.

object
certification_status
Certification status

The status of certification in device.

string
<= 1024 characters
device_firmware_version
Device Firmware version

The firmware version in device.

string
<= 1024 characters
device_name
Device name

The name for the device.

string
<= 1024 characters
ip_info
object
local
Local

Local IP address.

string
<= 1024 characters
traffic
Traffic

Traffic address.

string
<= 1024 characters
wan
WAN

WAN address.

string
<= 1024 characters
firmware_version
Firmware Version

The version of firmware for the cluster.

string
<= 1024 characters
infra_host_name
Infra host name

Infra host name should be “N/A”

string
<= 1024 characters
physical_hosted
object
devices
Devices

The devices assgined to the cluster.

Array<object>
Devices

The device details.

object
certification_status
Certification status

The status of certification in device.

string
<= 1024 characters
device_firmware_version
Device Firmware version

The firmware version in device.

string
<= 1024 characters
device_name
Device name

The name for the device.

string
<= 1024 characters
ip_info
object
local
Local

Local IP address.

string
<= 1024 characters
traffic
Traffic

Traffic address.

string
<= 1024 characters
wan
WAN

WAN address.

string
<= 1024 characters
firmware_version
Firmware Version

The version of firmware for the cluster.

string
<= 1024 characters
infra_host_name
Infra host name

Infra host name should be “N/A”

string
<= 1024 characters
traffic_type
string
default: WEB
Allowed values: WEB MOBILE
deployment_mode
string
default: REVERSE_PROXY
Allowed values: REVERSE_PROXY API_MODE
system_metadata
object
creation_timestamp
creation_timestamp

CreationTimestamp is a timestamp representing the server time when this object was created. It is not guaranteed to be set in happens-before order across separate operations. Clients may not set this value. It is represented in RFC3339 form and is in UTC.

string format: date-time
<= 1024 characters
creator_class
creator_class

A value identifying the class of the user or service which created this configuration object.

string
<= 1024 characters
creator_id
creator_id

A value identifying the exact user or service that created this configuration object.

string
<= 1024 characters
deletion_timestamp
deletion_timestamp

DeletionTimestamp is RFC 3339 date and time at which this resource will be deleted. This field is set by the server when a graceful deletion is requested by the user, and is not directly settable by a client. The resource is expected to be deleted (no longer visible from resource lists, and not reachable by name) after the time in this field, once the finalizers list is empty. As long as the finalizers list contains items, deletion is blocked. Once the deletionTimestamp is set, this value may not be unset or be set further into the future, although it may be shortened or the resource may be deleted prior to this time. For example, a user may request that a pod is deleted in 30 seconds. The Kubelet will react by sending a graceful termination signal to the containers in the pod. After that 30 seconds, the Kubelet will send a hard termination signal (SIGKILL) to the container and after cleanup, remove the pod from the API. In the presence of network partitions, this object may still exist after this timestamp, until an administrator or automated process can determine the resource is fully terminated. If not set, graceful deletion of the object has not been requested.

Populated by the system when a graceful deletion is requested. Read-only.

string format: date-time
<= 1024 characters
finalizers
finalizers

Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.

Array<string>
initializers
object
pending
pending

Pending is a list of initializers that must execute in order before this object is initialized. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.

Array<object>
InitializerType

Initializer is information about an initializer that has not yet completed.

object
name
name

Name of the service that is responsible for initializing this object.

string
>= 6 characters <= 1024 characters
result
object
code
code

Suggested HTTP return code for this status, 0 if not set.

integer format: int32
reason
reason

A human-readable description of why this operation is in the “Failure” status. If this value is empty there is no information available.

string
>= 27 characters <= 1024 characters
status
status

Status of the operation. One of: “Success” or “Failure”.

string
>= 17 characters <= 1024 characters
labels
labels

Map of string keys and values that can be used to organize and categorize (scope and select) objects as chosen by the operator or software. Values here can be interpreted by software(backend or frontend) to enable certain behavior e.g. Things marked as soft-deleted(restorable).

object
modification_timestamp
modification_timestamp

ModificationTimestamp is a timestamp representing the server time when this object was last modified.

string format: date-time
<= 1024 characters
object_index
object_index

Unique index for the object. Some objects need a unique integer index to be allocated for each object type. This field will be populated for all objects that need it and will be zero otherwise.

integer format: int64
owner_view
object
kind
kind

Kind of the view object.

string
>= 12 characters <= 1024 characters
name
name

When a configuration object(e.g. Virtual_host) refers to another(e.g route) then name will hold the referred object’s(e.g. Route’s) name.

string
>= 6 characters <= 1024 characters
namespace
namespace

When a configuration object(e.g. Virtual_host) refers to another(e.g route) then namespace will hold the referred object’s(e.g. Route’s) namespace.

string
>= 6 characters <= 1024 characters
uid
uid

UID of the view object.

string format: uuid
>= 36 characters <= 1024 characters
tenant
tenant

Tenant to which this configuration object belongs to. The value for this is found from presented credentials.

string
>= 6 characters <= 1024 characters
uid
uid

Uid is the unique in time and space value for this object. It is generated by the server on successful creation of an object and is not allowed to change on Replace API. The value of is taken from uid field of ObjectMetaType, if provided.

string format: uuid
>= 36 characters <= 1024 characters
Example
{
"spec": {
"bot_endpoint_policy_metadata": {
"type": "WEB"
},
"cloud_hosted": {
"egress": [
{
"region": "AP_NORTHEAST_1"
}
],
"ingress": [
{
"region": "AP_NORTHEAST_1"
}
]
},
"cluster_state": "ACTIVE",
"environment_type": "PRODUCTION",
"traffic_type": "WEB",
"deployment_mode": "REVERSE_PROXY"
}
}

Returned when operation is not authorized.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when there is no permission to access resource.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when resource is not found.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when operation on resource is conflicting with current value.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when operation has been rejected as it is happening too frequently.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when server encountered an error in processing API.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when service is unavailable temporarily.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when server timed out processing request.

Media typeapplication/json
string format: string
Examplegenerated
example